Leetcode 198. House Robber(动态规划经典题)

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.
Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.
Example 1:
Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
Total amount you can rob = 1 + 3 = 4.
Example 2:
Input: [2,7,9,3,1]
Output: 12
Explanation: Rob house 1 (money = 2), rob house 3 (money = 9) and rob house 5 (money = 1).
Total amount you can rob = 2 + 9 + 1 = 12.

中文:你是一个专业的小偷,计划偷窃沿街的房屋。每间房内都藏有一定的现金,影响你偷窃的唯一制约因素就是相邻的房屋装有相互连通的防盗系统,如果两间相邻的房屋在同一晚上被小偷闯入,系统会自动报警。
给定一个代表每个房屋存放金额的非负整数数组,计算你在不触动警报装置的情况下,能够偷窃到的最高金额。


分析:由于同时从相邻的两个房屋中盗取财宝就会触发报警器:故
a.若选择第i个房间的财宝,就一定不考虑第i-1个房间的财宝
b.若不选择第i个房间的财宝,则相当于考虑第前i-1个房间的财宝

四部曲:
1.确认原问题和子问题
原问题为求n个房间的最优解,子问题为求前1个房间,2个房间,…,前n-1个房间的最优解。
2.确认状态
第i个状态即为前i个房间能够获得的最大财宝(因为是单调递增的)
3.确认边界状态的值
前1个房间的最优解:选择第一个房间的财宝
前2个房间的最优解:max(第一个房间的财宝,第二个房间的财宝)
4.确定状态转移方程
a.选择第i个房间:第i个房间和前i-2个房间的最优解
b.不选择第i个房间:前i-1个房间的最优解
得到动态规划转移方程为:
dp[i]=max(dp[i-1],dp[i-2]+nums[i]) (i>=3)

步骤:
在这里插入图片描述
代码:

class Solution {
public:
    int rob(vector<int>& nums){
        int n=nums.size();
        if(n==0){
            return 0;
        }
        if(n==1){
            return nums[0];
        }
        vector<int> dp(n,0);
        dp[0]=nums[0];
        dp[1]=max(nums[0],nums[1]);
        for(int i=2;i<n;i++){
            dp[i]=max(dp[i-1],dp[i-2]+nums[i]);
        }
        return dp[n-1];
    }
};
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值